function [x,hist] = gaussseiadel(A,b)

n = size(A,1);
tol = 1e-8;
err = tol+1;
x = zeros(n,1);
xold = x;
iter=0;
hist.x=x;
while err> tol
   iter=iter+1;
   disp(['#iter:',num2str(iter)]);
   
   xold = x;
   for i=1:n
      sum1 = A(i,1:i-1)*x(1:i-1);
      sum2 = A(i,i+1:n)*x(i+1:n);
      x(i) = (b(i)-sum1-sum2)/A(i,i);
   end
   err = norm(x-xold,Inf);
   hist.x = [hist.x,x];
end
