function [x,hist] = gradient(A,b,x0)
% Implementa il metodo del gradiente

% parametri
iter = 0;
maxiter = 1000;
tol = 1e-8;
x = x0;
r = b-A*x0;
errore = norm(r);

% inizializza hist
hist = [];
hist.flag = 0;
hist.iter = 0;
hist.x = x;

% NORMA VETTORE B
bnrm2 = norm(b);
if bnrm2 < tol
   bnrm2 = 1.0;
end

% MAIN LOOP
while errore > bnrm2*tol & iter<maxiter
   iter = iter+1;
   disp(['#iter: ',num2str(iter)]);

   % alpha
   alpha = r'*r/(r'*A*r);
   
   % aggiorno x
   x = x+alpha*r;
   
   % residuo
   r = b-A*x;
   
   % errore
   errore = norm(r);
   
   % hist
   hist.x = [hist.x,x];
end

% hist
if errore > bnrm2*tol
   hist.flag = 1;
end
hist.iter = iter;
