% testGradient

close all
clear all
clc
A = [7.7959,3.8703;3.8703,3.2041];
b = [2.5477;8.656];
n = size(A,2);
xexact = A\b;

x0 = [1;0];

% Metodo del gradiente
[x,hist] = gradient(A,b,x0);

% determinazione della forma quadratica
syms x y s
s = [x,y]*sym(A)*[x;y]/sym(2)-sym(b)'*[x;y];
s = expand(s);
sexpr = vectorize(s);
funz = vectorize(s);
funz = strrep(funz,'x','XX');
funz = strrep(funz,'y','YY');

% visualliza iterazioni
offset = [4,6];
ndiv = 200;
xdiv = linspace(xexact(1)-offset(1),xexact(1)+offset(1),ndiv);
ydiv = linspace(xexact(2)-offset(2),xexact(2)+offset(2),ndiv);
[XX,YY] = meshgrid(xdiv,ydiv);
ZZ = eval(funz);

x = hist.x(1,:).';
y = hist.x(2,:).';
levels = eval(sexpr);
figure(1);
contour(XX,YY,ZZ,levels,'k');
hold on;
for i=1:size(hist.x,2)-1
   line([hist.x(1,i),hist.x(1,i+1)],[hist.x(2,i),hist.x(2,i+1)])
   plot(hist.x(1,i),hist.x(2,i),'b*');
end
plot(xexact(1),xexact(2),'r*');
hold off;

% GRADIENTE CONIUGATO
[x,hist] = gradientConj(A,b,x0);

% Visualizza iterazioni
x = hist.x(1,:).';
y = hist.x(2,:).';
levels = eval(sexpr);
figure(2);
contour(XX,YY,ZZ,levels,'k');
hold on;
for i=1:size(hist.x,2)-1
   line([hist.x(1,i),hist.x(1,i+1)],[hist.x(2,i),hist.x(2,i+1)])
   plot(hist.x(1,i),hist.x(2,i),'b*');
end
plot(xexact(1),xexact(2),'r*');
hold off;


break;
% GRADIENTE CONIUGATO PRECONDIZIONATO
clear all
close all
clc;
A = gallery('poisson',30);
n = size(A,1);
xexact = ones(n,1);
b = A*xexact;
x0 = zeros(n,1);
%[xg,histg] = gradient(A,b,x0);
[xgc,histgc] = gradientConj(A,b,x0);
[xgcp,histgcp] = gradientConjPrec(A,b,x0);
histg.iter,histgc.iter,histgcp.iter


% fill-in delle matrici
break;
close all
clear all
load('west0479.mat');
n = size(west0479,1);
A = west0479 + west0479' + speye(n)+...
   spdiags(ones(n,1)*1000000,n,n);
clear west0479;

figure(3);
A = gallery('poisson',30);
A(1,:) = 0.001;
A(:,1) = 0.001;
A(1,1) = 1000;
spy(A);

L = chol(full(A));
figure(4);
spy(L+L');

