close all;
clear all;
clc;


% PARAMETRI
alpha = 1e-12;
beta  = 40;
mu    = 1e-3;
gamma = 0.4;
E     = 0.4;
R     = 3300;


funcD = inline('alpha*(exp(v*beta)-1)-mu*v.*(v-gamma)','v','alpha','beta','mu','gamma');
funcJ = inline('(E-v)/R','v','E','R');


v = linspace(0,0.45);
dval = feval(funcD,v,alpha,beta,mu,gamma);
jval = feval(funcJ,v,E,R);

% Determinazione grafica del punto di lavoro
figure(1);
plot(v,dval,'b-',v,jval,'k-');
grid

f  = inline('v*(1/R+mu*gamma)-mu*v.^2+alpha*(exp(v*beta)-1)-E/R','v','alpha','beta','mu','gamma','E','R');
df = inline('  (1/R+mu*gamma)-2*mu*v +alpha*beta*exp(v*beta)','v','alpha','beta','mu','gamma','E','R');

fval = feval(f,v,alpha,beta,mu,gamma,E,R);

figure(1);
plot(v,fval,'b-');
grid

x0      = E;
toll    = 1e-10;
maxiter = 1000;

[x,hist] = newton(f,df,x0,toll,maxiter,alpha,beta,mu,gamma,E,R);
for i=1:length(hist.x)-1
    % linee tangenti
    h=line(hist.x(i:i+1),[hist.f(i),0]);
    set(h,'Color','r');
    % linee verticali
    h=line([hist.x(i),hist.x(i)],[0,hist.f(i)]);
    set(h,'Color','r','LineStyle','--');
end
