function [x,hist] = newton(f,df,x0,varargin)
% Metodo di Newton
%
% ESEMPIO DI UTILIZZO
% [x,hist] = newton(f,df,x0,toll,maxiter)

if nargin == 3
   toll    = 1e-8;
   maxiter = 1000;
end
if nargin >= 5
   toll    = varargin{1};
   maxiter = varargin{2};
end
if nargin<=2
   error('numero di argomenti non corretto!');
end
if nargin==4
   error('numero di argomenti non corretto!');
end


% history
hist = [];

% init
x = x0;
amp = toll+1;
iter = 0;

% salvataggio parametri
hist.param = [];
param.x0 = x0; param.toll=toll; param.maxiter = maxiter;
param.method = 'Newton';
hist.param = param;

hist.x    = [];
hist.f    = [];
hist.iter = [];

hist.x    = [hist.x;x0];
hist.f    = [hist.f;f(x0,varargin{3:end})];
hist.iter = [hist.iter;iter];

% ciclo principale
while amp > toll && iter < maxiter
   iter = iter+1;
   fval  = f(x,varargin{3:end});
   dfval = df(x,varargin{3:end});
   
   %if abs(dfval) < 10*eps
   %   error('df non esiste');
   %end
   
   xn = x-fval/dfval;
   amp = abs(xn-x);
   x = xn;
   % ATTENZIONE A MODIFICA
   hist.x    = [hist.x;x];
   hist.f    = [hist.f;f(x,varargin{3:end})];
   hist.iter = [hist.iter;iter];

end
